Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90	(revision 5075)
@@ -54,9 +54,5 @@
    USE icbini          ! handle bergs, initialisation
    USE icbstp          ! handle bergs, calving, themodynamics and transport
-#if defined key_oasis3
    USE cpl_oasis3      ! OASIS3 coupling
-#elif defined key_oasis4
-   USE cpl_oasis4      ! OASIS4 coupling (not working)
-#endif
    USE lib_mpp         ! distributed memory computing
 #if defined key_iomput
@@ -166,22 +162,23 @@
 #if defined key_iomput
       IF( Agrif_Root() ) THEN
-# if defined key_oasis3 || defined key_oasis4
-         CALL cpl_prism_init( ilocal_comm )      ! nemo local communicator given by oasis
-         CALL xios_initialize( "oceanx",local_comm=ilocal_comm )
-# else
-         CALL  xios_initialize( "nemo",return_comm=ilocal_comm )
-# endif
+         IF( lk_cpl ) THEN
+            CALL cpl_init( ilocal_comm )                               ! nemo local communicator given by oasis
+            CALL xios_initialize( "oceanx",local_comm=ilocal_comm )    ! send nemo communicator to xios
+         ELSE
+            CALL  xios_initialize( "nemo",return_comm=ilocal_comm )    ! nemo local communicator given by xios
+         ENDIF
+      ENDIF
       ENDIF
       narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection
 #else
-# if defined key_oasis3 || defined key_oasis4
-      IF( Agrif_Root() ) THEN
-         CALL cpl_prism_init( ilocal_comm )                 ! nemo local communicator given by oasis
-      ENDIF
-      narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection (control print return in cltxt)
-# else
-      ilocal_comm = 0
-      narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop )                ! Nodes selection (control print return in cltxt)
-# endif
+      IF( lk_cpl ) THEN
+         IF( Agrif_Root() ) THEN
+            CALL cpl_init( ilocal_comm )                               ! nemo local communicator given by oasis
+         ENDIF
+         narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection (control print return in cltxt)
+      ELSE
+         ilocal_comm = 0
+         narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop )                ! Nodes selection (control print return in cltxt)
+      ENDIF
 #endif
       narea = narea + 1                                     ! mynode return the rank of proc (0 --> jpnij -1 )
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 5075)
@@ -156,5 +156,9 @@
 #if defined key_lim2 || defined key_lim3
             IF(( nn_ice == 2 ) .OR. ( nn_ice == 3 )) THEN
-               CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', 1.0 - frld(:,:)   )
+	       IF(ALLOCATED(frld)) THEN
+                  CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', 1.0 - frld(:,:)   )
+               ELSE
+		  CALL ctl_warn('Ice concentration not written to background as ice variable frld not allocated on this timestep')
+	       ENDIF
             ENDIF
 #endif
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 5075)
@@ -56,14 +56,14 @@
     LOGICAL, PUBLIC, PARAMETER :: lk_asminc = .FALSE.  !: No assimilation increments
 #endif
-   LOGICAL, PUBLIC :: ln_bkgwri     !: No output of the background state fields
-   LOGICAL, PUBLIC :: ln_asmiau     !: No applying forcing with an assimilation increment
-   LOGICAL, PUBLIC :: ln_asmdin     !: No direct initialization
-   LOGICAL, PUBLIC :: ln_trainc     !: No tracer (T and S) assimilation increments
-   LOGICAL, PUBLIC :: ln_dyninc     !: No dynamics (u and v) assimilation increments
-   LOGICAL, PUBLIC :: ln_sshinc     !: No sea surface height assimilation increment
-   LOGICAL, PUBLIC :: ln_seaiceinc  !: No sea ice concentration increment
-   LOGICAL, PUBLIC :: ln_salfix     !: Apply minimum salinity check
+   LOGICAL, PUBLIC :: ln_bkgwri = .FALSE.      !: No output of the background state fields
+   LOGICAL, PUBLIC :: ln_asmiau = .FALSE.      !: No applying forcing with an assimilation increment
+   LOGICAL, PUBLIC :: ln_asmdin = .FALSE.      !: No direct initialization
+   LOGICAL, PUBLIC :: ln_trainc = .FALSE.      !: No tracer (T and S) assimilation increments
+   LOGICAL, PUBLIC :: ln_dyninc = .FALSE.      !: No dynamics (u and v) assimilation increments
+   LOGICAL, PUBLIC :: ln_sshinc = .FALSE.      !: No sea surface height assimilation increment
+   LOGICAL, PUBLIC :: ln_seaiceinc             !: No sea ice concentration increment
+   LOGICAL, PUBLIC :: ln_salfix = .FALSE.      !: Apply minimum salinity check
    LOGICAL, PUBLIC :: ln_temnofreeze = .FALSE. !: Don't allow the temperature to drop below freezing
-   INTEGER, PUBLIC :: nn_divdmp     !: Apply divergence damping filter nn_divdmp times
+   INTEGER, PUBLIC :: nn_divdmp                !: Apply divergence damping filter nn_divdmp times
 
    REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE ::   t_bkg   , s_bkg      !: Background temperature and salinity
@@ -109,12 +109,9 @@
       !! ** Action  : 
       !!----------------------------------------------------------------------
-      INTEGER :: ji, jj, jk
-      INTEGER :: jt
-      INTEGER :: imid
-      INTEGER :: inum
+      INTEGER :: ji, jj, jk, jt  ! dummy loop indices
+      INTEGER :: imid, inum      ! local integers
+      INTEGER :: ios             ! Local integer output status for namelist read
       INTEGER :: iiauper         ! Number of time steps in the IAU period
       INTEGER :: icycper         ! Number of time steps in the cycle
-      INTEGER :: ios             ! Local integer output status for namelist read
-
       REAL(KIND=dp) :: ditend_date     ! Date YYYYMMDD.HHMMSS of final time step
       REAL(KIND=dp) :: ditbkg_date     ! Date YYYYMMDD.HHMMSS of background time step for Jb term
@@ -124,12 +121,11 @@
 
       REAL(wp) :: znorm        ! Normalization factor for IAU weights
-      REAL(wp) :: ztotwgt      ! Value of time-integrated IAU weights 
-                               ! (should be equal to one)
+      REAL(wp) :: ztotwgt      ! Value of time-integrated IAU weights (should be equal to one)
       REAL(wp) :: z_inc_dateb  ! Start date of interval on which increment is valid
       REAL(wp) :: z_inc_datef  ! End date of interval on which increment is valid
       REAL(wp) :: zdate_bkg    ! Date in background state file for DI
       REAL(wp) :: zdate_inc    ! Time axis in increments file
-
-      REAL(wp), POINTER, DIMENSION(:,:) :: hdiv
+      !
+      REAL(wp), POINTER, DIMENSION(:,:) ::   hdiv   ! 2D workspace
       !!
       NAMELIST/nam_asminc/ ln_bkgwri,                                      &
@@ -137,6 +133,5 @@
          &                 ln_asmdin, ln_asmiau,                           &
          &                 nitbkg, nitdin, nitiaustr, nitiaufin, niaufn,   &
-         &                 ln_salfix, salfixmin,                &
-         &                 nn_divdmp
+         &                 ln_salfix, salfixmin, nn_divdmp
       !!----------------------------------------------------------------------
 
@@ -144,5 +139,4 @@
       ! Read Namelist nam_asminc : assimilation increment interface
       !-----------------------------------------------------------------------
-
       ln_seaiceinc = .FALSE.
       ln_temnofreeze = .FALSE.
@@ -570,7 +564,7 @@
       ! used to prevent the applied increments taking the temperature below the local freezing point 
 
-      DO jk=1, jpkm1
-         fzptnz (:,:,jk) = tfreez( tsn(:,:,jk,jp_sal), fsdept(:,:,jk) )
-      ENDDO
+      DO jk = 1, jpkm1
+         fzptnz(:,:,jk) = eos_fzp( tsn(:,:,jk,jp_sal), fsdept(:,:,jk) )
+      END DO
 
       IF ( ln_asmiau ) THEN
@@ -587,6 +581,5 @@
             IF(lwp) THEN
                WRITE(numout,*) 
-               WRITE(numout,*) 'tra_asm_inc : Tracer IAU at time step = ', &
-                  &  kt,' with IAU weight = ', wgtiau(it)
+               WRITE(numout,*) 'tra_asm_inc : Tracer IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
             ENDIF
@@ -636,6 +629,5 @@
             IF (ln_temnofreeze) THEN
                ! Do not apply negative increments if the temperature will fall below freezing
-               WHERE(t_bkginc(:,:,:) > 0.0_wp .OR. &
-                  &   tsn(:,:,:,jp_tem) + t_bkginc(:,:,:) > fzptnz(:,:,:) ) 
+               WHERE( t_bkginc(:,:,:) > 0.0_wp .OR. tsn(:,:,:,jp_tem) + t_bkginc(:,:,:) > fzptnz(:,:,:) ) 
                   tsn(:,:,:,jp_tem) = t_bkg(:,:,:) + t_bkginc(:,:,:)   
                END WHERE
@@ -646,6 +638,5 @@
                ! Do not apply negative increments if the salinity will fall below a specified
                ! minimum value salfixmin
-               WHERE(s_bkginc(:,:,:) > 0.0_wp .OR. &
-                  &   tsn(:,:,:,jp_sal) + s_bkginc(:,:,:) > salfixmin ) 
+               WHERE( s_bkginc(:,:,:) > 0.0_wp .OR. tsn(:,:,:,jp_sal) + s_bkginc(:,:,:) > salfixmin ) 
                   tsn(:,:,:,jp_sal) = s_bkg(:,:,:) + s_bkginc(:,:,:)   
                END WHERE
@@ -654,15 +645,20 @@
             ENDIF
 
-            tsb(:,:,:,:) = tsn(:,:,:,:)               ! Update before fields
-
-            CALL eos( tsb, rhd, rhop, gdept_0(:,:,:) )                ! Before potential and in situ densities
-         
+            tsb(:,:,:,:) = tsn(:,:,:,:)                 ! Update before fields
+
+            CALL eos( tsb, rhd, rhop, gdept_0(:,:,:) )  ! Before potential and in situ densities
+!!gm  fabien
+!            CALL eos( tsb, rhd, rhop )                ! Before potential and in situ densities
+!!gm
+
+
             IF( ln_zps .AND. .NOT. lk_c1d ) &
-               &  CALL zps_hde( nit000, jpts, tsb, &  ! Partial steps: before horizontal derivative
-               &                gtsu, gtsv, rhd,   &  ! of T, S, rd at the bottom ocean level
-               &                gru , grv )
+               &  CALL zps_hde( nit000, jpts, tsb, gtsu, gtsv,  &        ! Partial steps: before horizontal gradient
+               &                rhd, gru , grv, aru, arv, gzu, gzv, ge3ru, ge3rv,  &             !
+               &                gtui, gtvi, grui, grvi, arui, arvi, gzui, gzvi, ge3rui, ge3rvi  )  ! of t, s, rd at the last ocean level
 
 #if defined key_zdfkpp
             CALL eos( tsn, rhd, fsdept_n(:,:,:) )                      ! Compute rhd
+!!gm fabien            CALL eos( tsn, rhd )                      ! Compute rhd
 #endif
 
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 5075)
@@ -104,9 +104,10 @@
    REAL(wp),    DIMENSION(jp_bdy) ::   rn_time_dmp_out          !: Damping time scale in days at radiation outflow points
 
-#if ( defined key_lim2 || defined key_lim3 )
    CHARACTER(len=20), DIMENSION(jp_bdy) ::   cn_ice_lim       ! Choice of boundary condition for sea ice variables 
    INTEGER, DIMENSION(jp_bdy)           ::   nn_ice_lim_dta   !: = 0 use the initial state as bdy dta ; 
                                                               !: = 1 read it in a NetCDF file
-#endif
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_tem             !: choice of the temperature of incoming sea ice
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_sal             !: choice of the salinity    of incoming sea ice
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_age             !: choice of the age         of incoming sea ice
    !
    
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 5075)
@@ -676,5 +676,5 @@
                CALL iom_close ( inum )
                !CALL fld_clopn ( bn_a_i, nyear, nmonth, nday, ldstop=.TRUE. )
-               !CALL iom_open ( bn_a_i %clname, inum )
+               !CALL iom_open ( bn_a_i%clname, inum )
                !id1 = iom_varid ( bn_a_i%num, bn_a_i%clvar, kdimsz=zdimsz, kndims=zndims, ldstop = .FALSE. )
       	       IF ( zndims == 4 ) THEN
@@ -740,5 +740,5 @@
       jstart = 1
       DO ib_bdy = 1, nb_bdy
-         jend = nb_bdy_fld(ib_bdy) 
+         jend = jstart - 1 + nb_bdy_fld(ib_bdy) 
          CALL fld_fill( bf(jstart:jend), blf_i(jstart:jend), cn_dir_array(ib_bdy), 'bdy_dta',   &
          &              'open boundary conditions', 'nambdy_dta' )
@@ -907,4 +907,2 @@
    !!==============================================================================
 END MODULE bdydta
-
-
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 5075)
@@ -30,5 +30,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  !
-   USE domvvl
+   USE domvvl          ! variable volume
 
    IMPLICIT NONE
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn2d.F90	(revision 5075)
@@ -176,4 +176,6 @@
          spgu(ii, ij) = dta%ssh(jb)
       END DO
+
+      CALL lbc_bdy_lnk( spgu(:,:), 'T', 1., ib_bdy )
       !
       igrd = 2      ! Flather bc on u-velocity; 
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyice_lim.F90	(revision 5075)
@@ -24,11 +24,12 @@
    USE par_ice_2
    USE ice_2           ! LIM_2 ice variables
+   USE dom_ice_2       ! sea-ice domain
 #elif defined key_lim3
    USE par_ice
    USE ice             ! LIM_3 ice variables
+   USE dom_ice         ! sea-ice domain
 #endif 
    USE par_oce         ! ocean parameters
    USE dom_oce         ! ocean space and time domain variables 
-   USE dom_ice          ! sea-ice domain
    USE sbc_oce         ! Surface boundary condition: ocean fields
    USE bdy_oce         ! ocean open boundary conditions
@@ -44,6 +45,4 @@
    PUBLIC   bdy_ice_lim_dyn ! routine called in limrhg
 
-   REAL(wp) ::   epsi20 = 1.e-20_wp  ! module constants
-   REAL(wp) ::   epsi10 = 1.e-10_wp  ! min area allowed by ice model
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
@@ -97,9 +96,6 @@
       INTEGER  ::   ji, jj, ii, ij     ! local scalar
       REAL(wp) ::   zwgt, zwgt1        ! local scalar
-      REAL(wp) ::   zinda, ztmelts, zdh
-
-      REAL(wp), PARAMETER  ::   zsal = 6.3    ! arbitrary salinity    for incoming ice
-      REAL(wp), PARAMETER  ::   ztem = 270.0  ! arbitrary temperature for incoming ice
-      REAL(wp), PARAMETER  ::   zage = 30.0   ! arbitrary age         for incoming ice
+      REAL(wp) ::   ztmelts, zdh
+
       !!------------------------------------------------------------------------------
       !
@@ -117,43 +113,4 @@
          hicif(ji,jj) = ( hicif(ji,jj) * zwgt1 + dta%hicif(jb) * zwgt ) * tmask(ji,jj,1)     ! Ice depth 
          hsnif(ji,jj) = ( hsnif(ji,jj) * zwgt1 + dta%hsnif(jb) * zwgt ) * tmask(ji,jj,1)     ! Snow depth
-
-!         zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - frld(ji,jj) ) ) ! 0 if no ice
-!         !------------------------------
-!         ! Sea ice surface temperature
-!         !------------------------------
-!         sist(ji,jj)   = zinda * 270.0 + ( 1.0 - zinda ) * tfu(ji,jj)
-!         !-----------------------------------------------
-!         ! Ice/snow temperatures and energy stored in brines 
-!         !-----------------------------------------------
-!         !!! TO BE CONTIUNED (as LIM3 below) !!!
-!            zindhe = MAX( 0.e0, SIGN( 1.e0, fcor(1,jj) ) )              ! = 0 for SH, =1 for NH
-! 
-!               ! Recover in situ values.
-!               zindb         = MAX( rzero, SIGN( rone, zs0a(ji,jj) - epsi06 ) )
-!               zacrith       = 1.0 - ( zindhe * acrit(1) + ( 1.0 - zindhe ) * acrit(2) )
-!               zs0a (ji,jj)  = zindb * MIN( zs0a(ji,jj), zacrith )
-!               hsnif(ji,jj)  = zindb * ( zs0sn(ji,jj) /MAX( zs0a(ji,jj), epsi16 ) )
-!               hicif(ji,jj)  = zindb * ( zs0ice(ji,jj)/MAX( zs0a(ji,jj), epsi16 ) )
-!               zindsn        = MAX( rzero, SIGN( rone, hsnif(ji,jj) - epsi06 ) )
-!               zindic        = MAX( rzero, SIGN( rone, hicif(ji,jj) - epsi03 ) )
-!               zindb         = MAX( zindsn, zindic )
-!               zs0a (ji,jj)  = zindb * zs0a(ji,jj)
-!               frld (ji,jj)  = 1.0 - zs0a(ji,jj)
-!               hsnif(ji,jj)  = zindsn * hsnif(ji,jj)
-!               hicif(ji,jj)  = zindic * hicif(ji,jj)
-!               zusvosn       = 1.0/MAX( hsnif(ji,jj) * zs0a(ji,jj), epsi16 )
-!               zusvoic       = 1.0/MAX( hicif(ji,jj) * zs0a(ji,jj), epsi16 )
-!               zignm         = MAX( rzero,  SIGN( rone, hsndif - hsnif(ji,jj) ) )
-!               zrtt          = 173.15 * rone 
-!               ztsn          =          zignm   * tbif(ji,jj,1)  &
-!                              + ( 1.0 - zignm ) * MIN( MAX( zrtt, rt0_snow * zusvosn * zs0c0(ji,jj)) , tfu(ji,jj) ) 
-!               ztic1          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c1(ji,jj) ) , tfu(ji,jj) )
-!               ztic2          = MIN( MAX( zrtt, rt0_ice * zusvoic * zs0c2(ji,jj) ) , tfu(ji,jj) )
-! 
-!               tbif(ji,jj,1) = zindsn * ztsn  + ( 1.0 - zindsn ) * tfu(ji,jj)               
-!               tbif(ji,jj,2) = zindic * ztic1 + ( 1.0 - zindic ) * tfu(ji,jj)
-!               tbif(ji,jj,3) = zindic * ztic2 + ( 1.0 - zindic ) * tfu(ji,jj)
-!               qstoif(ji,jj) = zindb  * xlic * zs0st(ji,jj) /  MAX( zs0a(ji,jj), epsi16 )
-
       END DO 
 
@@ -217,10 +174,10 @@
             IF ( v_ice(ji  ,jj-1) > 0. .AND. vmask(ji  ,jj+1,1) == 0. ) jpbound = 1; ii = ji  ; ij = jj-1
 
-            zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ii,ij) + 0.01 ) ) ! 0 if no ice
+            rswitch = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ii,ij) + 0.01 ) ) ! 0 if no ice
 
             ! concentration and thickness
-            a_i (ji,jj,jl) = a_i (ii,ij,jl) * zinda
-            ht_i(ji,jj,jl) = ht_i(ii,ij,jl) * zinda
-            ht_s(ji,jj,jl) = ht_s(ii,ij,jl) * zinda
+            a_i (ji,jj,jl) = a_i (ii,ij,jl) * rswitch
+            ht_i(ji,jj,jl) = ht_i(ii,ij,jl) * rswitch
+            ht_s(ji,jj,jl) = ht_s(ii,ij,jl) * rswitch
 
             ! Ice and snow volumes
@@ -233,13 +190,13 @@
 
                ! Ice salinity, age, temperature
-               sm_i(ji,jj,jl)   = zinda * zsal  + ( 1.0 - zinda ) * s_i_min
-               o_i(ji,jj,jl)    = zinda * zage  + ( 1.0 - zinda )
-               t_su(ji,jj,jl)   = zinda * ztem  + ( 1.0 - zinda ) * ztem
+               sm_i(ji,jj,jl)   = rswitch * rn_ice_sal(ib_bdy)  + ( 1.0 - rswitch ) * s_i_min
+               o_i(ji,jj,jl)    = rswitch * rn_ice_age(ib_bdy)  + ( 1.0 - rswitch )
+               t_su(ji,jj,jl)   = rswitch * rn_ice_tem(ib_bdy)  + ( 1.0 - rswitch ) * rn_ice_tem(ib_bdy)
                DO jk = 1, nlay_s
-                  t_s(ji,jj,jk,jl) = zinda * ztem + ( 1.0 - zinda ) * rtt
+                  t_s(ji,jj,jk,jl) = rswitch * rn_ice_tem(ib_bdy) + ( 1.0 - rswitch ) * rtt
                END DO
                DO jk = 1, nlay_i
-                  t_i(ji,jj,jk,jl) = zinda * ztem + ( 1.0 - zinda ) * rtt 
-                  s_i(ji,jj,jk,jl) = zinda * zsal + ( 1.0 - zinda ) * s_i_min
+                  t_i(ji,jj,jk,jl) = rswitch * rn_ice_tem(ib_bdy) + ( 1.0 - rswitch ) * rtt 
+                  s_i(ji,jj,jk,jl) = rswitch * rn_ice_sal(ib_bdy) + ( 1.0 - rswitch ) * s_i_min
                END DO
                
@@ -247,16 +204,22 @@
  
                ! Ice salinity, age, temperature
-               sm_i(ji,jj,jl)   = zinda * sm_i(ii,ij,jl)  + ( 1.0 - zinda ) * s_i_min
-               o_i(ji,jj,jl)    = zinda * o_i(ii,ij,jl)   + ( 1.0 - zinda )
-               t_su(ji,jj,jl)   = zinda * t_su(ii,ij,jl)  + ( 1.0 - zinda ) * rtt
+               sm_i(ji,jj,jl)   = rswitch * sm_i(ii,ij,jl)  + ( 1.0 - rswitch ) * s_i_min
+               o_i(ji,jj,jl)    = rswitch * o_i(ii,ij,jl)   + ( 1.0 - rswitch )
+               t_su(ji,jj,jl)   = rswitch * t_su(ii,ij,jl)  + ( 1.0 - rswitch ) * rtt
                DO jk = 1, nlay_s
-                  t_s(ji,jj,jk,jl) = zinda * t_s(ii,ij,jk,jl) + ( 1.0 - zinda ) * rtt
+                  t_s(ji,jj,jk,jl) = rswitch * t_s(ii,ij,jk,jl) + ( 1.0 - rswitch ) * rtt
                END DO
                DO jk = 1, nlay_i
-                  t_i(ji,jj,jk,jl) = zinda * t_i(ii,ij,jk,jl) + ( 1.0 - zinda ) * rtt
-                  s_i(ji,jj,jk,jl) = zinda * s_i(ii,ij,jk,jl) + ( 1.0 - zinda ) * s_i_min
+                  t_i(ji,jj,jk,jl) = rswitch * t_i(ii,ij,jk,jl) + ( 1.0 - rswitch ) * rtt
+                  s_i(ji,jj,jk,jl) = rswitch * s_i(ii,ij,jk,jl) + ( 1.0 - rswitch ) * s_i_min
                END DO
 
             END SELECT
+
+            ! if salinity is constant, then overwrite rn_ice_sal
+            IF( num_sal == 1 ) THEN
+               sm_i(ji,jj,jl)   = bulk_sal
+               s_i (ji,jj,:,jl) = bulk_sal
+            ENDIF
 
             ! contents
@@ -265,5 +228,5 @@
             DO jk = 1, nlay_s
                ! Snow energy of melting
-               e_s(ji,jj,jk,jl) = zinda * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
+               e_s(ji,jj,jk,jl) = rswitch * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
                ! Change dimensions
                e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
@@ -274,5 +237,5 @@
                ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K                  
                ! heat content per unit volume
-               e_i(ji,jj,jk,jl) = zinda * rhoic * &
+               e_i(ji,jj,jk,jl) = rswitch * rhoic * &
                   (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
                   +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-epsi20) ) &
@@ -331,5 +294,5 @@
       INTEGER  ::   ji, jj             ! local scalar
       INTEGER  ::   ib_bdy ! Loop index
-      REAL(wp) ::   zmsk1, zmsk2, zflag, zinda 
+      REAL(wp) ::   zmsk1, zmsk2, zflag
      !!------------------------------------------------------------------------------
       !
@@ -338,5 +301,5 @@
       DO ib_bdy=1, nb_bdy
          !
-         SELECT CASE( nn_ice_lim(ib_bdy) )
+         SELECT CASE( cn_ice_lim(ib_bdy) )
 
          CASE('none')
@@ -355,5 +318,5 @@
                   ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
                   jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
-                  zflag = idx_bdy(ib_bdy)%flagu(jb)
+                  zflag = idx_bdy(ib_bdy)%flagu(jb,jgrd)
                   
                   IF ( ABS( zflag ) == 1. ) THEN  ! eastern and western boundaries
@@ -371,6 +334,6 @@
                   ENDIF
                   ! mask ice velocities
-                  zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
-                  u_ice(ji,jj) = zinda * u_ice(ji,jj)
+                  rswitch = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
+                  u_ice(ji,jj) = rswitch * u_ice(ji,jj)
                   
                ENDDO
@@ -384,5 +347,5 @@
                   ji    = idx_bdy(ib_bdy)%nbi(jb,jgrd)
                   jj    = idx_bdy(ib_bdy)%nbj(jb,jgrd)
-                  zflag = idx_bdy(ib_bdy)%flagv(jb)
+                  zflag = idx_bdy(ib_bdy)%flagv(jb,jgrd)
                   
                   IF ( ABS( zflag ) == 1. ) THEN  ! northern and southern boundaries
@@ -400,6 +363,6 @@
                   ENDIF
                   ! mask ice velocities
-                  zinda = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
-                  v_ice(ji,jj) = zinda * v_ice(ji,jj)
+                  rswitch = 1.0 - MAX( 0.0_wp , SIGN ( 1.0_wp , - at_i(ji,jj) + 0.01 ) ) ! 0 if no ice
+                  v_ice(ji,jj) = rswitch * v_ice(ji,jj)
                   
                ENDDO
Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 5075)
@@ -100,7 +100,6 @@
          &             cn_dyn3d, nn_dyn3d_dta, cn_tra, nn_tra_dta,             &  
          &             ln_tra_dmp, ln_dyn3d_dmp, rn_time_dmp, rn_time_dmp_out, &
-#if ( defined key_lim2 || defined key_lim3 )
          &             cn_ice_lim, nn_ice_lim_dta,                           &
-#endif
+         &             rn_ice_tem, rn_ice_sal, rn_ice_age,                 &
          &             ln_vol, nn_volctl, nn_rimwidth
       !!
@@ -359,4 +358,7 @@
         ENDIF
         IF(lwp) WRITE(numout,*)
+        IF(lwp) WRITE(numout,*) '      tem of bdy sea-ice = ', rn_ice_tem(ib_bdy)         
+        IF(lwp) WRITE(numout,*) '      sal of bdy sea-ice = ', rn_ice_sal(ib_bdy)         
+        IF(lwp) WRITE(numout,*) '      age of bdy sea-ice = ', rn_ice_age(ib_bdy)         
 #endif
 
@@ -1152,9 +1154,9 @@
          END DO
 
-         tmask_i (:,:) = tmask(:,:,1) * tmask_i(:,:)
+         tmask_i (:,:) = ssmask(:,:) * tmask_i(:,:)
 
       ENDIF ! ln_mask_file=.TRUE.
       
-      bdytmask(:,:) = tmask(:,:,1)
+      bdytmask(:,:) = ssmask(:,:)
       IF( .not. ln_mask_file ) THEN
          ! If .not. ln_mask_file then we need to derive mask on U and V grid 
